# Copyright (C) 2016-2017  Yannick Jadoul
#
# This file is part of Parselmouth.
#
# Parselmouth is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Parselmouth is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Parselmouth.  If not, see <http://www.gnu.org/licenses/>

set(SRC_ROOT ${CMAKE_CURRENT_SOURCE_DIR})

macro (add_sources)
    file(RELATIVE_PATH _relPath "${SRC_ROOT}" "${CMAKE_CURRENT_SOURCE_DIR}")
    foreach(_src ${ARGN})
        if(_relPath)
            list(APPEND SRC "${_relPath}/${_src}")
        else()
            list(APPEND SRC "${_src}")
        endif()
    endforeach()
    if(_relPath)
        set(SRC ${SRC} PARENT_SCOPE)
    endif()
endmacro()
